import MoleculeDropdownList from '@s-ui/react-molecule-dropdown-list';
import MoleculeInputTags from '@s-ui/react-molecule-input-tags';
import MoleculeInputSelect from './MoleculeInputSelect.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var MoleculeSelectFieldMultiSelection = function MoleculeSelectFieldMultiSelection(props) {
  /* eslint-disable react/prop-types */
  var children = props.children,
    isOpen = props.isOpen,
    onToggle = props.onToggle,
    onChange = props.onChange,
    iconArrowDown = props.iconArrowDown,
    iconCloseTag = props.iconCloseTag,
    refMoleculeSelect = props.refMoleculeSelect,
    values = props.value,
    placeholder = props.placeholder,
    keysSelection = props.keysSelection,
    id = props.id,
    size = props.size,
    required = props.required,
    _props$optionsData = props.optionsData,
    optionsData = _props$optionsData === void 0 ? {} : _props$optionsData,
    selectSize = props.selectSize,
    tabIndex = props.tabIndex,
    maxTags = props.maxTags;
  var tags = values.map(function (value) {
    return optionsData[value];
  });
  var handleMultiSelection = function handleMultiSelection(ev, _ref) {
    var valueOptionSelected = _ref.value;
    var handleToggle = function handleToggle(ev) {
      var key = ev.key;
      var isKeySelection = keysSelection.includes(key);
      if (ev.key !== undefined && !isKeySelection) onToggle(ev, {
        isOpen: false
      });
    };
    var isValueSelectedAlreadySelected = function isValueSelectedAlreadySelected() {
      return values.includes(valueOptionSelected);
    };
    var removeFromValues = function removeFromValues() {
      return values.filter(function (value) {
        return value !== valueOptionSelected;
      });
    };
    var addToValues = function addToValues() {
      return [].concat(values, [valueOptionSelected]);
    };
    var isFull = function isFull() {
      return maxTags && (tags == null ? void 0 : tags.length) >= maxTags;
    };
    if (isValueSelectedAlreadySelected()) {
      onChange(ev, {
        value: removeFromValues()
      });
    } else if (!isFull()) {
      onChange(ev, {
        value: addToValues()
      });
    }
    handleToggle(ev);
  };
  var handleChangeTags = function handleChangeTags(ev, _ref2) {
    var value = _ref2.tags;
    onChange(ev, {
      value: value
    });
    refMoleculeSelect.current.focus();
  };
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(MoleculeInputSelect, {
      id: id,
      tags: tags,
      onClick: onToggle,
      tagsCloseIcon: iconCloseTag,
      iconArrowDown: iconArrowDown,
      onChangeTags: handleChangeTags,
      isOpen: isOpen,
      placeholder: !values.length ? placeholder : '',
      optionsData: optionsData,
      autoComplete: "off",
      noBorder: true,
      required: required,
      size: selectSize,
      tabIndex: tabIndex,
      maxTags: maxTags,
      value: "",
      children: /*#__PURE__*/_jsx(MoleculeInputTags, {})
    }), /*#__PURE__*/_jsx(MoleculeDropdownList, {
      checkbox: true,
      size: size,
      visible: isOpen,
      onSelect: handleMultiSelection,
      value: values,
      children: children
    })]
  });
};
MoleculeSelectFieldMultiSelection.displayName = 'MoleculeSelectFieldMultiSelection';
MoleculeSelectFieldMultiSelection.defaultProps = {
  value: []
};
export default MoleculeSelectFieldMultiSelection;